#include <stdlib.h>
#include <stdio.h>

main(int argc, char **argv)
{
	int i,j,k,n,l;
	unsigned char buf[256];
	unsigned char wav[256];
	FILE *fp,*fpo;

	if (argc<3) {
		printf("Use: %s <tape_file.tap> <raw_samples_file>\n",argv[0]);
		exit(1);
	}

	if((fp=fopen(argv[1],"rb"))==NULL) {perror("fopen read"); exit(1);}
	if((fpo=fopen(argv[2],"wb"))==NULL){perror("fopen write"); exit(1);}
	
	fread(buf,1,20,fp); // get rid of header 
	
	for (;;) {
		n=fread(buf,1,256,fp); 
		if (n<=0) break;
		for (j=0;j<n;j++) {
			// pulses are byte_value*4us long, and our sampling rate is 11520Hz
			// so, we have to multiply byte_value by 11520*4e-6 that is 
			// roughly 47/1024. The rounded result is the number of samples,
			// both low and high.
			l=(buf[j]*47+512)>>10;
			for (k=0;k<l;k++) wav[k]=0;		// Low samples
			for (;k<2*l;k++) wav[k]=0xff;	// high samples
			fwrite(wav,1,2*l,fpo);
		}
	}
	fclose(fp);
	fclose(fpo);
	printf("%s written\n",argv[2]);
}
