#include <stdlib.h>
#include <stdio.h>
#include <string.h>

int nvsf;
unsigned char vsf[1<<20];
unsigned char sna[1<<16];

unsigned char *getblk(char *name)
{
	int i,j;
	unsigned char buf[16];
	unsigned char *p;
	
	strcpy(buf,name);
	for(i=strlen(name);i<16;i++) buf[i]=0;
	
	p=&vsf[0x3A];
	do {
		for (i=0;i<16;i++) if (p[i]!=buf[i]) break;
		if (i==16) break;
		j=p[18]+(p[19]<<8)+(p[20]<<16)+(p[21]<<24);
		//printf("%s j=%x (%x)\n",p,j,j+((int)p-(int)vsf));
		p=&p[j];
	} while (p<=&vsf[nvsf]);
	if (i!=16) return NULL;
	return p;
}

main(int argc, char **argv)
{
	unsigned int i,j,np,npv,nb;
	unsigned char *p, *preg,*pram, *pvram;;
	FILE *fp;

	if((fp=fopen(argv[1],"rb"))==NULL) exit(1);
	nvsf=fread(vsf,1,1<<20,fp); // read VSF file 
	fclose(fp);
	
	
	p=getblk("PETMEM"); 
	printf("%s: ",p);
	p=&p[22];
	np=p[2]*4;
	npv=((p[0]&3)<2)?4:8;
	sna[0]=np;
	sna[1]=npv+0x80;
	preg=&sna[2];
	pram=&preg[32];
	pvram=&pram[np*256];
	nb=(unsigned int)(&pvram[npv*256])-(unsigned int)sna;
	printf("%dK, video: %dK, sna:%d bytes\n",np/4,npv/4,nb);

	memcpy(pram,&p[5],np*256);
	memcpy(pvram,&p[5+np*256],npv*256);
	
	p=getblk("MAINCPU");
	printf("%s ",p);
	printf("A=$%02x X=$%02x Y=$%02x S=$%02x P=$%02x PC=$%04x\n",
		p[30],p[31],p[32],p[33],p[36],p[34]+(p[35]<<8) );
	preg[0]=p[30];
	preg[1]=p[31];
	preg[2]=p[32];
	preg[3]=p[33];
	preg[4]=p[36];
	preg[5]=p[34];
	preg[6]=p[35];

	p=getblk("VIA");
	printf("%s\n",p);
	preg[8+0]= p[22+2];  // ORB
	preg[8+1]= p[22+0];  // ORA
	preg[8+2]= p[22+3];  // DDRB
	preg[8+3]= p[22+1];  // DDRA
	preg[8+4]= p[22+6];  // T1 counter L
	preg[8+5]= p[22+7];  // T1 counter H
	preg[8+6]= p[22+4];  // T1 latch L
	preg[8+7]= p[22+5];  // T1 latch H
	preg[8+8]= p[22+8];  // T2 latch Low
	preg[8+9]= p[22+10]; // T2 counter H 
	preg[8+10]=p[22+15]; // SR
	preg[8+11]=p[22+16]; // ACR
	preg[8+12]=p[22+17]; // PCR
	preg[8+13]=p[22+18]; // IFR
	preg[8+14]=p[22+20]; // IER
	printf("ORB=$%02x DDRB=$%02x\n",preg[8+0],preg[8+2]);
	printf("ORA=$%02x DDRA=$%02x\n",preg[8+1],preg[8+3]);
	printf("T1=$%04x T1latch=$%04x\n",preg[8+4]+(preg[8+5]<<8),
		preg[8+6]+(preg[8+7]<<8));
	printf("T2latchL=$%02x\n",preg[8+8]);
	printf("SR= $%02x\n", preg[8+10]);
	printf("ACR=$%02x\n", preg[8+11]);
	printf("PCR=$%02x\n", preg[8+12]);
	printf("IFR=$%02x\n", preg[8+13]);
	printf("IER=$%02x\n", preg[8+14]);
	
	if (argc<3) exit(1);
	if((fp=fopen(argv[2],"wb"))==NULL) exit(1);
	fwrite(sna,1,nb,fp); 
	fclose(fp);
	
}
