`ifdef ICECREAM
  `define XRAM
`endif

`ifdef SIMRETRO
  `define XRAM
  `define VIDEO2PIN
  `include "pllsr.v"
`else
  `include "pll.v"
`endif


`include "system.v"

module main(
	output TXD, 
	input  RXD, 
	input  CLKIN, 

`ifdef XRAM
	inout  [15:0]XD,
	output [15:0]XA,
	output XWE,
	output XOE,
	output XBHE,
	output XBLE,
`endif

	input  MISO,
	output MOSI,
	output SCK,
	output SSBF,
		
	input KCLK,
	input KDAT,
	

`ifdef SIMRETRO	
	output [3:0]R,
	output [3:0]G,
	output HSYN,
	output PWM
`else
	output AUDIO,
	output [2:0]LED,
	inout  VIDEO,
	output SYN,
	output [2:0]ANT
`endif
);

wire clk,pll_lock;

//-- Instanciar el PLL
pll
  pll1(
	.clock_in(CLKIN),
	.clock_out(clk),
	.locked(pll_lock)
	);

SYSTEM sys0( .clk(clk), .video(VIDEO), .ant(ANT), .syn(SYN),
		.sck(SCK), .miso(MISO), .mosi(MOSI), .ssb(SSBF), .debug(LED),
		.kclk(KCLK), .kdat(KDAT), .audio(AUDIO),
		.txd(TXD), .rxd(RXD), .debug(LED)
`ifdef XRAM
		,.xd(XD), .xa(XA), .xble(XBLE), .xbhe(XBHE), .xoe(XOE), .xwe(XWE)
`endif		
);
`ifdef SIMRETRO
  wire AUDIO;
  assign PWM=AUDIO;
  wire [2:0]ANT;
  wire [2:0]LED;
  wire SYN;
  wire VIDEO;
  assign HSYN=SYN;
  assign R = (~SYN) ? 4'd0 : (VIDEO ? 4'd15 : 4'd6);
  //assign G = R;
`endif
endmodule


