//-------------------------------------------------------------------
//-------------------------------------------------------------------

`include "system.v"
module tb();

//-- Registros con señales de entrada
reg clk=0;
reg rxd=1;
wire sck, miso, mosi, ssb;
//-- Instanciamos 
SYSTEM sys0 ( .clk(clk), .sck(sck), .mosi(mosi), .miso(miso), .ssb(ssb),
	.kclk(1'b1), .kdat(1'b1), .rxd(rxd)
 );
// External Flash SPI (simulated here)
FLASHSPI flashmem (
	.sck(sck), .mosi(mosi), .miso(miso), .ssb(ssb)
);
// Reloj periódico
always #5 clk=~clk;

//-- Proceso al inicio
initial begin
	//-- Fichero donde almacenar los resultados
	$dumpfile("tb.vcd");
	$dumpvars(0, tb);

	#4167 rxd=0;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;

	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=1;

	#4167 rxd=0;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;
	#4167 rxd=1;

	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=0;
	#4167 rxd=1;

	//# 319 $display("FIN de la simulacion");
	//# 20000000 $finish;
	# 1500000 $finish;
end



endmodule

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------
//-- External SPI
//----------------------------------------------------------------------------

module FLASHSPI(
	input sck,
	input mosi,
	output miso,
	input ssb
);

reg [22:0]cnt=0;
always @(posedge sck or posedge ssb) if (ssb) cnt<=0; else cnt<=cnt+1;

reg [23:0]sh;
always @(posedge sck) sh<={sh[22:0],mosi};
reg [7:0]cmd;
reg[23:0]addr;
always @(posedge sck or posedge ssb) if (ssb) cmd<=0; else if (cnt==8) cmd<=sh[7:0];

always @(negedge sck or posedge ssb)
  if (ssb) addr<=0; else 
	if ((cmd==3)&(cnt==32)) addr<=sh; else
	if ((cnt>31) & (bit==0) & (cmd==3)) begin
		addr<=addr+1;
	end
reg [2:0]bit;
always @(negedge sck) bit<=~cnt[2:0];
wire [19:0]wrapaddr=addr[19:0];
wire [7:0]do=mem[wrapaddr]; 
assign miso=(cnt<32)? 1'b0 : do[bit];

reg [7:0]mem[0:(1<<20)-1];

initial begin
  $readmemh("FlashROM.hex", mem);
end
endmodule

